
/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */





// displays the text in the title
function displayTitle(text) {
	var title = getObj('fulltitle');
	if(title) {
		title.innerHTML = text;
	}
}




// adds a channel-header for the grouped view
function addChannelHeader(channel_id, option_arr) {
	var channel = availableChannels[channel_id];
	if(channel) {
		var parent = document.getElementById("content");
		
		// main
		var paragraph = document.createElement("p");
		paragraph.setAttribute("id", "channelHeader_" + channel_id);
		paragraph.setAttribute("class", "headerRow");
		var headerTitle = document.createTextNode(channel.getName());
		paragraph.appendChild(headerTitle);
		
		// options
		if(option_arr) {
			var valid_options = new Array('closeButton', 'plusButton', 'minusButton');
			var container = document.createElement("div");
			container.setAttribute("class", "extraHeaderUtilities");
			
			for(var i = 0; i < option_arr.length; i++) {
				var type = option_arr[i];
				if(inArray(type, valid_options)) {
					var canv = document.createElement("canvas");
					canv.setAttribute('id', type + "_" + channel_id);
					canv.setAttribute('class', "extraHeaderItem");
					canv.setAttribute('width', canvasWidthHeight);
					canv.setAttribute('height', canvasWidthHeight);
					canv.setAttribute('lang', type);
					canv.setAttribute('onmousedown', "canvasPressed(this)");
					canv.setAttribute('onmouseup', "canvasReleased(this)");
					canv.setAttribute('onmouseout', "canvasReleased(this)");
					
					drawControlButton(canv.getContext("2d"), type);
					
					//changeNumGroupEntries(-1)
					switch(option_arr[i]) {
						case 'closeButton':		canv.setAttribute("onclick", "displaySetting['day'] = 0; displaySetting['channelsOfGroup'] = previouslyShownChannelGroup; displaySetting['time'] = displaySetting['previousDisplaySettingStartTime']; updateTVListing();");		break;
						case 'plusButton':		canv.setAttribute("onclick", "displaySetting['day'] = 0; changeNumGrouped(1);");		break;
						case 'minusButton':		canv.setAttribute("onclick", "displaySetting['day'] = 0; changeNumGrouped(-1);");		break;
					}
					
					container.appendChild(canv);
				}
			}
			
			paragraph.appendChild(container);
		}
		
		parent.appendChild(paragraph);
	}
}


function addDateHeader(date)
{
	var datestring = dayAndDate(date);
	var parent = getObj("content");
	
	// main <p>
	var paragraph = document.createElement("div");
	paragraph.setAttribute("class", "dateRow");
	var headerTitle = document.createTextNode(datestring);
	paragraph.appendChild(headerTitle);
	
	parent.appendChild(paragraph);
}



// toggle the search options sheet
var searchOptionsSheetDiv = null;
function toggleSearchOptions() {
	if(isCollapsed()) {
		return;
	}
	
	if(!possibleSearchOptions) {
		alert("possibleSearchOptions is undefined. Aborting.");		// should not happen
		return;
	}
	
	// hide (and save) options
	if(searchOptionsSheetDiv) {
		searchOptions = new Array();
		for(var i = 0; i < possibleSearchOptions.length; i++) {
			var opt = possibleSearchOptions[i];
			var input = getObj("searchOption_" + opt);
			if(input && input.checked) {
				searchOptions.push(opt);
			}
		}
		if(searchOptions.length < 1) {
			searchOptions.push('title');
		}
		if(window.widget) {
			widget.setPreferenceForKey(searchOptions.join("|"), "searchOptions");
		}
		
		searchOptionsSheetDiv.parentNode.removeChild(searchOptionsSheetDiv);
		searchOptionsSheetDiv = null;
		
		try {
			getObj("searchInput").focus();
		}
		catch(exc) {  }
		
		var currentSearchString = getObj('searchInput').value;
		if ('' != currentSearchString) immediateSearch(currentSearchString);
	}
	
	// show options
	else {
		var parent = document.createElement('div');
		parent.setAttribute('class', "toolbarListParent");
		
		var parent2 = document.createElement('div');
		parent2.setAttribute('id', "searchOptionsSheet");
		
		var closer = document.createElement('div');
		closer.setAttribute('class', "optCloser");
		closer.addEventListener('click', toggleSearchOptions, null);
		
		var sheet = document.createElement('div');
		sheet.setAttribute('class', "optSheet");
		
		var div = document.createElement('div');
		div.setAttribute('class', "toolbarListItem toolbarListItemActive");
		div.innerHTML = locStr("Suchen in");
		sheet.appendChild(div);
		
		for(var i = 0; i < possibleSearchOptions.length; i++) {
			var opt = possibleSearchOptions[i];
			var div = document.createElement('div');
			div.setAttribute('class', "toolbarListItem");
			div.innerHTML = "<input type='checkbox' id=\"searchOption_" + opt + "\" name='" + opt + "' value='true'" + (inArray(opt, searchOptions) ? 'checked="checked"' : '') + " /><label onclick=\"selectVal(this)\">" + locStr("searchOption " + opt) + "</label></div>";
			sheet.appendChild(div);
		}
		
		parent2.appendChild(closer);
		parent2.appendChild(sheet);
		parent.appendChild(parent2);
		searchOptionsSheetDiv = parent;
		getObj('frontDiv').appendChild(parent);
	}
	
	// update the icon
	var icon = getObj("searchOptions");
	if(icon) {
		icon.style.backgroundImage = searchOptionsSheetDiv ? "url('Images/searchOptions_active.png')" : '';
	}
}





/*
 ***************
 * Drawer	   *
 ***************
 */

var drawer = {	_duration:250, duration:0, start:null, stop:null, timeout:null,		// animation duration (duration is set from _duration every time anim starts)
				from:0, current:0, to:44, _minheight:42, _maxheight:0.5,
				_topoffset:38, _toppadding:22, _bottomoffset:9 };					// distance from window-top to mainViewArea-top, toolbar-height, drawerseparator-height

function showInDrawer(text, extraClass) {
	var div = getObj('drawercontent');
	if(div) {
		cleanNode(div);
		if(!text) {
			text = "<span class=\"faded\">" + locStr("Klicken Sie auf den Namen einer Sendung") + "</span>";
		}
		
		if('string' == typeof(text)) {
			div.innerHTML = "<div class='drawertext'>" + text + "</div>";
		}
		else {
			text.setAttribute('class', "drawertext");
			div.appendChild(text);
		}
		div.setAttribute('class', (extraClass ? extraClass : ''));
	}
}


// resizes the drawer with animation
function resizeDrawer(force_toggle, slowAnim) {
	var now = (new Date()).getTime();
	if(drawer.stop && (drawer.stop > now)) {
		clearTimeout(drawer.timeout);
		drawer.timeout = null;
	}
	
	drawer.start = now;
	drawer.duration = (slowAnim ? 10* drawer._duration : drawer._duration);
	drawer.stop = now + drawer.duration;
	
	drawer.from = drawer.current;
	if(('close' == force_toggle) || (force_toggle && drawer.current > 0)) {
		drawer.to = 0;
	}
	else {
		drawer.to = parseInt(getComputedValue('height', getObj('drawercontent'))) + 2;
	}
	
	// min/max?
	var max = parseInt(getComputedValue('height', getObj('mainViewArea'))) - drawer._toppadding;
	if(drawer.to > (drawer._maxheight * max)) {
		drawer.to = Math.round(drawer._maxheight * max);
	}
	
	if(drawer.to != drawer.from) {
		animateDrawer();
	}
	else {
		calculateAndShowThumb('myScrollBar', getObj('content'));
		calculateAndShowThumb('myDrawerScrollBar', getObj('drawercontent'));
	}
}


function toggleDrawer(event) {
	resizeDrawer(1, (event && event.shiftKey));
}

// repeatedly calls resizeDrawerTo until the end of the animation-time
function animateDrawer() {
	var now = (new Date()).getTime();
	if(now < drawer.stop) {
		var delta = (now - drawer.start) / drawer.duration;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var size = (drawer.from * (1-factor)) + (factor * drawer.to);
		
		resizeDrawerTo(size);
		drawer.timeout = setTimeout("animateDrawer()", 10);
	}
	
	// animation finished
	else {
		resizeDrawerTo(drawer.to);
		
		// check for our show and scroll our show into view
		if(lastActiveShow && showHash[lastActiveShow]) {
			scrollIntoView2(showHash[lastActiveShow].p, 'content');
			if(drawer.current > 0) {
				lastActiveShow && showHash[lastActiveShow].drawCanvas('showInDrawer');
			}
		}
		
		if(drawer.current > 0) {
			calculateAndShowThumb('myScrollBar', getObj('content'));
			calculateAndShowThumb('myDrawerScrollBar', getObj('drawercontent'));
		}
	}
}


// this is used to generally size the drawer
function resizeDrawerTo(height) {
	var drawerDiv = getObj('drawer');
	var parentDiv = getObj('parentDiv');
	
	// min/max?
	if(height < 0) {
		height = 0;
	}
	else {
		var max = parseInt(getComputedValue('height', getObj('mainViewArea')));
		if(height > (drawer._maxheight * max)) {
			height = Math.round(drawer._maxheight * max);
		}
	}
	
	drawer.current = height;
	drawerDiv.style.height = height + 'px';									// grow drawerbox
	parentDiv.style.bottom = (1* drawer._bottomoffset + height) + 'px';		// move bottom of main table
	
	calculateAndShowThumb('myScrollBar', getObj('contentcontent'));
}


// hides the drawer without animation
function hideDrawer() {
	if(drawer.current == 0)
		return;
	
	resizeDrawerTo(0);
}


// resizes the drawer manually
function resizeDrawerManually(event) {
	var y = event.y;
	var offset = parseInt(getComputedValue('height', getObj('mainViewArea')));
	drawer.to = (offset + drawer._topoffset) - y - Math.round(drawer._bottomoffset / 2);
	
	// "plop" the drawer at bottom
	if(drawer.to < (drawer._minheight / 2)) {
		drawer.to = 0;
	}
	else if(drawer.to < drawer._minheight) {
		drawer.to = drawer._minheight;
	}
	
	// resize
	calculateAndShowThumb('myDrawerScrollBar', getObj('drawercontent'));
	resizeDrawerTo(drawer.to);
}


function catchDrawerResizing(event) {
	document.addEventListener("mousemove", resizeDrawerManually, false);
	document.addEventListener("mouseup", releaseDrawerResizing, false);
	event.stopPropagation();
	event.preventDefault();
}

function releaseDrawerResizing(event) {
	document.removeEventListener("mousemove", resizeDrawerManually, false);
	document.removeEventListener("mouseup", releaseDrawerResizing, false);
	event.stopPropagation();
	event.preventDefault();
}











/*
 ***********************
 * Control Buttons	   *
 ***********************
 */
var controlButtons = {};
var downOnControlButton = null;
var activeSwitchControlButton = 'modeSwitch1';				// 2.0: Change this to get the value from the prefs
var switchControlButtonForMode = Object();
switchControlButtonForMode['single'] = 'modeSwitch1';
switchControlButtonForMode['grouped'] = 'modeSwitch2';
switchControlButtonForMode['magazine'] = 'modeSwitch3';

function controlButton(id) {
	if(! this instanceof controlButton) {
		return new controlButton(id);
	}
	
	if(controlButtons[id])
		return controlButtons[id];
	
	this.id = id;
	this.active = (activeSwitchControlButton == this.id);
	this.enabled = true;
	
	this.func = null;
	this.image = '';
	this.div = null;
	
	this.mousedown = false;
	
	
	// Methods
	this.getXHTML = function() {
		var div = document.createElement('div');
		div.setAttribute('id', id);
		div.setAttribute('class', "controlButton");
		div.setAttribute('onmousedown', "controlButtonDown(event)");
		div.setAttribute('onmouseover', "controlButtonHovered(event)");
		div.setAttribute('onmouseout', "controlButtonOut(event)");
		
		
		this.div = div;
		this.setImage(this.active ? '_active' : '');
		
		return this.div;
	}
	
	this.down = function(event) {
		if(this.enabled) {
			this.mousedown = true;
			downOnControlButton = this;
			
			document.addEventListener('mouseup', controlButtonUp, false);
			event.stopPropagation();
			event.preventDefault();
			
			this.setImage('_active');
		}
	}
	
	// this actually calls the assigned function
	this.up = function(mouse_released_outside) {
		if(this.mousedown) {
			this.mousedown = false;
			document.removeEventListener('mouseup', controlButtonUp, false);
			
			// cancel click
			if(mouse_released_outside) {
				downOnControlButton = null;
			}
			
			// do it!
			else {
				if('modeSwitch' == this.id.substr(0, 10)) {
					if(activeSwitchControlButton && (this.id != activeSwitchControlButton) && controlButtons[activeSwitchControlButton]) {
						controlButtons[activeSwitchControlButton].deactivate();
					}
					
					activeSwitchControlButton = this.id;
					this.active = true;
				}
				else {
					this.setImage('_hover');
				}
				
				this.func();
			}
		}
	}
	
	this.hovered = function() {
		if(!this.active) {
			if(this.mousedown) {
				this.setImage('_active');
			}
			else if(this.enabled) {
				this.setImage('_hover');
			}
		}
	}
	
	this.out = function() {
		if(this.enabled && !this.active) {
			this.setImage();
		}
	}
	
	this.setActive = function() {
		if(!this.active) {
			this.setImage('_active');
			this.active = true;
		}
	}
	
	this.deactivate = function() {
		if(this.active) {
			this.setImage();
			this.active = false;
		}
	}
	
	this.enable = function() {
		this.enabled = true;
		this.div.style.opacity = 1.0;
		this.setImage();
	}
	
	this.disable = function() {
		this.enabled = false;
		this.div.style.opacity = 0.5;
		this.setImage();
	}
	
	this.setImage = function(suffix) {
		if(this.div) {
			this.div.style.backgroundImage = "url(Images/" + this.image + (suffix ? suffix : '') + ".png)";
		}
	}
	
	
	// init
	this.init = function() {
		switch(this.id) {
			case "modeSwitch1":			this.func = function() { changeDisplayMode('single'); };		this.image = "control_mode1";			break;
			case "modeSwitch2":			this.func = function() { changeDisplayMode('grouped'); };		this.image = "control_mode2";			break;
			case "modeSwitch3":			this.func = function() { changeDisplayMode('magazine'); };		this.image = "control_mode3";			break;
			case "previousShows":		this.func = showPrevious;										this.image = "control_arrowLeft";		break;
			case "nextShows":			this.func = showNext;											this.image = "control_arrowRight";		break;
			default:					this.func = null;												this.image = "control_mode1";			break;
		}
		
		// preload images
		var img = new Image();
		img.src = "Images/" + this.image + ".png";
		img.src = "Images/" + this.image + "_hover.png";
		img.src = "Images/" + this.image + "_active.png";
	}
	
	this.init();
	controlButtons[id] = this;
}

function controlButtonDown(event) {
	var id = event.target ? event.target.getAttribute('id') : null;
	if(id && controlButtons[id]) {
		controlButtons[id].down(event);
	}
}

function controlButtonUp(event) {
	var id = event.target ? event.target.getAttribute('id') : null;
	if(id && controlButtons[id] && (downOnControlButton == controlButtons[id])) {
		controlButtons[id].up();
	}
	else if(downOnControlButton) {
		downOnControlButton.up(true);
	}
}

function controlButtonHovered(event) {
	var id = event.target ? event.target.getAttribute('id') : null;
	if(id && controlButtons[id]) {
		controlButtons[id].hovered();
	}
}

function controlButtonOut(event) {
	var id = event.target ? event.target.getAttribute('id') : null;
	if(id && controlButtons[id]) {
		controlButtons[id].out();
	}
}


// inits all controlbuttons PLUS the cacheindicator-div
function initControlBar() {
	var arr = new Array("modeSwitch1", "modeSwitch2", "modeSwitch3", "previousShows", "nextShows");
	var parent = getObj('controls');
	
	for(var i = 0; i < arr.length; i++) {
		var but = new controlButton(arr[i]);
		but.getXHTML();
		parent.appendChild(but.div);
	}
	
	// cacheindicator
	var ind = document.createElement('div');
	ind.setAttribute('id', "cacheindicator");
	ind.setAttribute('class', "blackinset");
	parent.appendChild(ind);
}

// sets the appropriate state for each of our buttons
function controlButtonUpdate() {
	if(controlButtons) {
		var should_be_active = switchControlButtonForMode[displaySetting['mode']];
		activeSwitchControlButton = null;
		for(var but in controlButtons) {
			var button = controlButtons[but];
			if(but == should_be_active) {
				button.setActive();
				activeSwitchControlButton = but;
			}
			else {
				button.deactivate();
			}
		}
	}
}







/*
 *******************
 * ProgressBar	   *
 *******************
 */

var progressanim = { mainProgress:null }

// call this to start the animation. It will create, setup and run the animation
function startProgressAnim(which) {
	if(dialogShown || isCollapsed())
		return;
	
	if(!which) {
		which = "mainProgress";
	}
	if(progressanim[which]) {				// already running
		playProgressAnim(which);
		return;
	}
	
	progressanim[which] = createProgressAnim(which);
	
	// display the divs
	if("mainProgress" == which) {
		getObj("progressDiv").style.display = "block";
	}
	
	setTimeout("initProgressAnim('" + which + "')", 10);
}

// inits the desired animation when it has loaded
function initProgressAnim(which) {
	if(!progressanim[which])
		return;
	
	var loaded = progressanim[which].loaded();
	if(!loaded) {
		setTimeout("initProgressAnim('" + which + "')", 100);
		return;
	}
	
	// main progress blob
	if("mainProgress" == which) {
		progressanim[which].setInputValue("Duration", 1.5);
		progressanim[which].setInputValue("NumItems", 10);
		progressanim[which].setInputValue("Radius", 0.4);
		progressanim[which].setInputValue("MinWidth", 0.03);
		progressanim[which].setInputValue("MaxWidth", 0.25);
	}
	
	// the small one
	/*else if(1) {
		progressanim[which].setInputValue("NumItems", 6);		// Duration, NumItems, Red, Green, Blue, Radius, MinWidth, MaxWidth
		progressanim[which].setInputValue("Red", 0);
		progressanim[which].setInputValue("Green", 0);
		progressanim[which].setInputValue("Blue", 0);
	}*/
}

// appends the desired animation code the our DOM
function createProgressAnim(which) {
	var comp = null;
	
	comp = getObj(which);
	if(!comp) {
		if("mainProgress" == which) {
			getObj('mainProgressParent').innerHTML = '<embed id="mainProgress" type="application/x-quartzcomposer" width="150px" height="150px" src="Images/ProgressAnimation.qtz" autoplay="true" opaque="false"></embed>';
			comp = getObj(which);
		}
	}
	
	return comp;
}

function stopProgressAnim(which) {	
	if(progressanim[which]) {
		try {
			progressanim[which].stop();
			delete progressanim[which];
		}
		catch(exc) {  }
	}
	
	// clean up
	if("mainProgress" == which) {
		cleanNode(getObj('mainProgressParent'));
		getObj("progressDiv").style.display = "none";
	}
}

function playProgressAnim(which) {
	if(progressanim[which] && progressanim[which].play && !progressanim[which].playing()) {
		progressanim[which].play();
	}
}

function pauseProgressAnim(which) {
	if(progressanim[which] && progressanim[which].pause && progressanim[which].paused()) {
		progressanim[which].pause();
	}
}







var cachingIndicator = { interval:null, step:0 };
var cachingImagesLoaded = false;

function startCacheIndicator(and_text) {
	setCacheIndicatorText(and_text ? and_text : "lade Daten");
	if(null != cachingIndicator.interval)
		return;
	
	// preload images
	if(!cachingImagesLoaded) {
		for(var i = 0; i < 12; i++) {
			var img = new Image();
			img.src = "Images/progressBlob/progress" + i + ".png";
		}
		cachingImagesLoaded = true;
	}
	
	animateCacheIndicator();
	cachingIndicator.interval = setInterval("animateCacheIndicator()", 80);
}

function stopCacheIndicator() {
	if(cachingIndicator.interval) {
		clearInterval(cachingIndicator.interval);
		cachingIndicator.interval = null;
		
		var obj = getObj("cacheindicator");
		if(obj) {
			obj.style.backgroundImage = "url()";
		}
		setCacheIndicatorText('');
	}
}

function animateCacheIndicator() {
	var obj = getObj("cacheindicator");
	if(obj) {
		obj.style.backgroundImage = "url(Images/progressBlob/progress" + cachingIndicator.step + ".png)";
		
		cachingIndicator.step++;
		cachingIndicator.step = (cachingIndicator.step > 11) ? 0 : cachingIndicator.step;
	}
}

function setCacheIndicatorText(text) {
	var obj = getObj("cacheindicator");
	if(obj) {
		obj.innerHTML = text;
	}
}










/*
 *******************
 * The poof        *
 *******************
 */


function showPoof(x, y) {
 	if(getObj("poof"))
 		getObj("poof").parentNode.removeChild(getObj("poof"));
 	
 	// create the poof
 	var my_x = x + 10;
 	var my_y = y - 15;
 	var canvas = document.createElement("canvas");
 	canvas.setAttribute("id", "poof");
 	canvas.setAttribute("style", "top:" + my_y + "px; left:" + my_x + "px;");
 	canvas.setAttribute('width', 30);
 	canvas.setAttribute('height', 30);
 	
 	var parent = prefsShown ? getObj('prefDiv') : getObj('frontDiv');
 	parent.appendChild(canvas);
 	getObj("poofSound").Play();
 	
 	// make sure it animates
 	animatePoof(1);
 	setTimeout("animatePoof(2)", 100);
 	setTimeout("animatePoof(3)", 200);
 	setTimeout("animatePoof(4)", 300);
 	setTimeout("animatePoof(5)", 400);
 	
 	// make sure we remove it
  	setTimeout("getObj('poof').parentNode.removeChild(getObj('poof'))", 500);
}
 
function animatePoof(step)
{
	var img = new Image();
	img.src = "/System/Library/CoreServices/Dock.app/Contents/Resources/poof.png";
	var canvas = getObj("poof");
	try {
		var context = canvas.getContext("2d");
		context.clearRect(0, 0, 30, 30);
		context.drawImage(img, 0, (step-1)*128, 128, 128, 0, 0, 30, 30);
	}
	catch(exc) {  }
}
 
function blendFromTo(from_id, to_id) {
	var from = getObj(from_id);
	var to = getObj(to_id);
	
	if(from && to) {
		from.style.display = 'none';
		to.style.display = 'block';
	}
}








/*
 ************
 *  Dialog  *
 ************
 */


var dialogShown = false;
var dialogWaiting = new Array();
var dialogAnimation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function showDialog(showText, button1Text, button1Handle, button2Text, button2Handle, additionalText) {
	stopProgressAnim("mainProgress");
	stopCacheIndicator();
	
	// fading out current dialog? Stop animation
	if(null != dialogAnimation.timer) {
		clearInterval(dialogAnimation.timer);
		dialogAnimation.timer = null;
		removeDialog();
	}
	
	// already a dialog shown? Put to the stack
	if(dialogShown) {
		var dialog = { text:showText, but1T:button1Text, but1H:button1Handle, but2T:button2Text, but2H:button2Handle, additional:additionalText }
		dialogWaiting.push(dialog);
		anotherDialogWaiting();
		return;
	}
	
	// the text
	var div = document.createElement("div");
	div.setAttribute("id", "theOnlyDialog");
	div.setAttribute("class", "dialogDiv");
	div.innerHTML = showText ? showText : locStr("kein Text angegeben");
	
	if(additionalText) {
		var add = document.createElement("div");
		add.setAttribute('class', "dialogBoxedContent");
		add.innerHTML = additionalText;
		div.appendChild(add);
	}
	
	// the buttons
	if(button1Text) {
		var buttonbar = document.createElement("div");
		buttonbar.setAttribute("class", "dialogButtonBar");
		
		var b1 = document.createElement("div");
		b1.setAttribute("class", "dialog-button dialog-button-up");
		buttonbar.appendChild(b1);
		createDialogButton(b1, button1Text, button1Handle, 80);
	}
	
	if(button2Text) {
		var b2 = document.createElement("div");
		b2.setAttribute("class", "dialog-button dialog-button-up");
		buttonbar.appendChild(b2);
		createDialogButton(b2, button2Text, button2Handle, 80);
	}
	
	// do it
	div.appendChild(buttonbar);
	getObj("mainViewArea").appendChild(div);
	
	// too much text?
	if(additionalText) {
		var top = add.offsetTop;
		var height = add.offsetHeight;
		var maxHeight = add.parentNode.parentNode.offsetHeight - 60;		// 60 Pixels for the button-bar
		
		if(height > (maxHeight - top)) {
			add.style.height = (maxHeight - top) + 'px';
		}
	}
	
	blendDialogIn();
	anotherDialogWaiting();
	//calculateAndShowThumb('myScrollBar', getObj('content'));
}

function removeDialog() {
	if(dialogShown) {
		var dialog = getObj("theOnlyDialog");
		dialog.parentNode.removeChild(dialog);
	}
	
	dialogShown = false;
}

function anotherDialogWaiting() {
	if(dialogShown) {
		var id = "dialogWaitingReminder";
		var warn = getObj(id);
		
		if(dialogWaiting.length > 0) {
			if(!warn) {
				warn = document.createElement('div');
				warn.setAttribute('id', id);
				getObj("theOnlyDialog").appendChild(warn);
			}
			warn.innerHTML = dialogWaiting.length + " " + locStr("weitere") + " <a href=\"javascript:blendDialogOut(true)\">" + locStr("alle schliessen") + "</a>";
		}
		else if(warn) {
			try {
				warn.parentNode.removeChild(warn);
			}
			catch(exc) {  }
		}
	}
}

function blendDialogIn() {
	if(dialogShown)
		return;
	
	if(dialogAnimation.timer != null) {
		clearInterval(dialogAnimation.timer);
		dialogAnimation.timer = null;
	}
	
	var starttime = (new Date).getTime() - 13;

	dialogAnimation.duration = 300;
	dialogAnimation.starttime = starttime;
	dialogAnimation.firstElement = getObj("theOnlyDialog");
	dialogAnimation.timer = setInterval("animateDialog();", 13);
	dialogAnimation.from = dialogAnimation.now;
	dialogAnimation.to = 1.0;
	
	animateDialog();
	dialogShown = true;
}


function blendDialogOut(force_all_out) {
	if(!dialogShown)
		return;
	
	if(force_all_out) {
		dialogWaiting = new Array();
	}
	
	// if another dialog is waiting, display that one instead of blending out
	if(dialogWaiting.length > 0) {
		removeDialog();
		var dialog = dialogWaiting.shift();
		showDialog(dialog.text, dialog.but1T, dialog.but1H, dialog.but2T, dialog.but2H, dialog.additional);
		return;
	}
	
	// fade out the info button
	if (dialogAnimation.timer != null)
	{
		clearInterval (dialogAnimation.timer);
		dialogAnimation.timer	= null;
	}

	var starttime = (new Date).getTime() - 13;

	dialogAnimation.duration = 300;
	dialogAnimation.starttime = starttime;
	dialogAnimation.firstElement = getObj("theOnlyDialog");
	dialogAnimation.timer = setInterval("animateDialog();", 13);
	dialogAnimation.from = dialogAnimation.now;
	dialogAnimation.to = 0.0;
	
	animateDialog();
}

// animate-function below used
function animateDialog() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time - dialogAnimation.starttime, 0, dialogAnimation.duration);

	if (T >= dialogAnimation.duration) {
		clearInterval(dialogAnimation.timer);
		dialogAnimation.timer = null;
		dialogAnimation.now = dialogAnimation.to;
		
		// clean up after blending out
		if(dialogAnimation.to == 0.0)
			removeDialog();
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / dialogAnimation.duration));
		dialogAnimation.now = computeNextFloat (dialogAnimation.from, dialogAnimation.to, ease);
	}

	dialogAnimation.firstElement.style.opacity = dialogAnimation.now;
}







/*
 *	Fontsize Slider
 */

var fontsizeSliderActive = false;

function setFontsizeSliderTo(fontsize) {
	fontsize = (fontsize < 10) ? 10 : ((fontsize > 20) ? 20 : fontsize);
	getObj("mainFontSize").innerHTML = fontsize;
	mainFontSize = fontsize;
	
	var slider = getObj('fontsizeSlider');
	var fraction = (fontsize - 10) / 10;
	fraction = (fraction >= 0 && fraction <= 1) ? fraction : 0.4;
	
	var availWidth = slider.parentNode.offsetWidth ? slider.parentNode.offsetWidth : 140;		// only available when visible
	var left = (fraction * availWidth) - 10;			// could use "slider.offsetWidth / 2"
	
	slider.style.left = left + 'px';
}


// adjusts mainFontSize while dragging. Size can be changed between 10px and 20px
function adjustFontsize(event) {
	if(fontsizeSliderActive) {
		var slider = getObj('fontsizeSlider');
		
		var foo = getAbsoluteCoordinates(slider.parentNode).split(':');
		var x = event.x - foo[0];
		
		// round fraction to 0.1
		var fraction = Math.round(10 * (x / slider.parentNode.offsetWidth));
		fraction /= 10;
		fraction = (fraction < 0) ? 0 : ((fraction > 1) ? 1 : fraction);
		
		var fontsize = (10 * fraction) + 10;
		
		setFontsizeSliderTo(fontsize);
		updateFontsizePreview(fontsize);
	}
	else {
		fontsizeSliderReleased();
	}
}

function fontsizeSliderPressed(event) {
	fontsizeSliderActive = true;
	document.addEventListener('mousemove', adjustFontsize, false);
	document.addEventListener('mouseup', fontsizeSliderReleased, false);
	
	createFontsizePreview();
	
	adjustFontsize(event);
}

function fontsizeSliderReleased() {
	fontsizeSliderActive = false;
	document.removeEventListener('mousemove', adjustFontsize, false);
	document.removeEventListener('mouseup', fontsizeSliderReleased, false);
	
	removeFontsizePreview();
	//setMainFontSize(14);
}


var fakeShows = new Array();

function createFontsizePreview() {
	var div = document.createElement('div');
	div.setAttribute('id', "fontsizePreview");
	var panel = document.createElement('div');
	panel.setAttribute('class', "fontsizePreview");
	
	var shadow_body = document.createElement('div');
	shadow_body.setAttribute('style', "position:absolute; top:0px; left:30px; right:30px; bottom:0px; background:url(Images/Shadow_120_body.png) top left repeat-x;");
	var shadow_right = document.createElement('img');
	shadow_right.src = "Images/Shadow_120_right.png";
	shadow_right.setAttribute('style', "position:absolute; top:0px; right:0px; bottom:0px; width:30px;");
	
	div.appendChild(shadow_body);
	div.appendChild(shadow_right);
	div.appendChild(panel);
	getObj('prefDiv').appendChild(div);
	
	// add the shows
	var showids = FernsehPlugin.showsOnChannel(channelGroup1.join("\n"), 0, 0, 6, displaySetting['genre']);
	if(showids) {
		for(var i = 0; i < showids.length; i++) {
			var show = new Show(showids[i]);
			if(show.loadData()) {
				var row = show.getMainRow();
				row.setAttribute('class', ((0 == i % 2) ? 'mainRow' : 'mainRow altColor'));
				panel.appendChild(row);
				
				show.drawCanvas();
				fakeShows.push(show);
			}
		}
	}
	else {
		panel.innerHTML = "<span class='faded'>No shows loaded yet!</span>";
	}
}

function updateFontsizePreview(size) {
	var div = getObj('fontsizePreview');
	if(div) {
		size = (size < 10) ? 10 : ((size > 20) ? 20 : size);
		div.style.fontSize = size + "px";
		canvasWidthHeight = size;
		
		if(fakeShows && fakeShows.length) {
			for(var i = 0; i < fakeShows.length; i++) {
				fakeShows[i].drawCanvas();
			}
		}
	}
}

function removeFontsizePreview() {
	var div = getObj('fontsizePreview');
	if(div) {
		fakeShows = new Array();
		div.parentNode.removeChild(div);
	}
}

function fadeFontsizePreview() {
	var div = getObj('fontsizePreview');
	if(div) {
		div.style.opacity = 0.5;
	}
}






/*******************************
 *    Dragging divs around     *
 *           divDrag           *
 *******************************/

// the LANG attribute of a node serves as its identifier. There can't be two identical LANG attributes in the same parent!
// Draggable elements must have an object (which calls divDragDown()) WITHIN another object which holds the LANG attribute and
// calls divDragHover() (and serves as the actual dragged element)
 
 
var divDrag = {
			parent:null,
			
			element:null,
			originalElement:null,
			elementHeight:0,
			originX:0,		originY:0,
			returnStart:0,	returnStop:0,
			startX:0,		startY:0,
			placeholder:null,
			dupeElement:null,
			
			dragClickDelay:200,
			animDuration:300,
			dragDownTimeout:null,
			lastClickedTime:null
		};


// initiates the dragging action by calling divDragIsDown() after a timeout which will be cancelled by divDragUp() if the interval was too short
function divDragDown(event) {
	var now = (new Date()).getTime();
	
	divDrag.lastClickedTime = now;
	divDragDownEvent = event;
	
	document.addEventListener("mousemove", divDragMove, true);
	document.addEventListener("mouseup", divDragUp, true);
	event.stopPropagation();
	event.preventDefault();
	
	divDrag.dragDownTimeout = setTimeout("divDragIsDown()", divDrag.dragClickDelay);
}

function divDragIsDown() {
	if(!divDragDownEvent)
		return;
	
	var event = divDragDownEvent;
	divDragDownEvent = null;
	
	// get the element and the parent, cancel if no element or if there is already a dragged element
	var dragged = event.target.parentNode;
	if(!dragged || divDrag.element)
		return;
	
	divDrag.originalElement = dragged;
	
	// this is a possible parent - insert the placeholder
	if(dragged.parentNode && "divDrag_not_a_parent" != dragged.parentNode.getAttribute('lang')) {
		divDrag.parent = dragged.parentNode;
		divDrag.parent.insertBefore(divDragPlaceholder(), dragged);
		dragged.setAttribute('class', dragged.getAttribute('class') + " divDrag_original");
	}
	
	// this is not a possible target - we keep the original
	else {
		dragged.setAttribute('class', dragged.getAttribute('class') + " divDrag_originalCloned");
	}
	
	// get the moveable element
	divDrag.element = divDragDraggableElement(event);
}

function divDragMove(event) {
	if(divDrag.element) {
		divDrag.element.style.left = (1* event.x + 10) + "px";
		divDrag.element.style.top = (event.y - (divDrag.elementHeight / 3)) + "px";
	
		event.stopPropagation();
		event.preventDefault();
	}
}


// called when ending the drag. Cancells a too short drag or - if drag successful - inserts the original element at the current placeholders position or moves it back to the origin
function divDragUp(event) {
	document.removeEventListener("mousemove", divDragMove, true);
	document.removeEventListener("mouseup", divDragUp, true);
	event.stopPropagation();
	event.preventDefault();
	
	var now = (new Date()).getTime();
	if(divDrag.lastClickedTime && ((1* divDrag.lastClickedTime + divDrag.dragClickDelay) > now)) {		// mousedown was too short, cancel drag
		clearTimeout(divDrag.dragDownTimeout);
		divDragDownEvent = null;
		return;
	}
	
	// insert original element at placeholder's location or move it back to the original place
	if(divDrag.element) {
		var now = (new Date()).getTime();
		divDrag.returnStart = now;
		divDrag.returnStop = now + divDrag.animDuration;
		divDrag.startX = event.x + 10;
		divDrag.startY = event.y - (divDrag.element.offsetHeight / 3);
		
		// calc offset of placeholder or originalElement
		var xy = getAbsoluteCoordinates((divDrag.placeholder && divDrag.parent) ? divDrag.placeholder : divDrag.originalElement).split(':');
		divDrag.originX = xy[0];
		divDrag.originY = xy[1] - 2;
		
		setTimeout("divDragAnimateTo()", 10);
	}
}


// called when hovering an element
function divDragHover(event) {
	if(!divDrag.element)
		return;
	
	var element = event.target;
	
	// hovering an item, create a new placeholder and insert
	if(element.hasAttribute('class') && element.getAttribute('class').match(/divDrag_item/)) {
		if(element.parentNode != divDrag.parent) {
			if(!divDragNewParent(element.parentNode))
				return;
		}
		
		divDragRemovePlaceholder();
		element.parentNode.insertBefore(divDragPlaceholder(), element);
	}
	
	// hovering the parent
	else if(element.hasAttribute('lang') && ('divDrag_qualified_parent' == element.getAttribute('lang'))) {
		if(element != divDrag.parent) {
			divDragNewParent(element);
		}
		else {
			divDragRemovePlaceholder();
			element.appendChild(divDragPlaceholder());
		}
	}
}


function divDragNewParent(parent) {
	// stop here if not dragging, if parent stays the same or if parent is not qualified
	if(!divDrag.element || !parent || (divDrag.parent == parent) || ('divDrag_qualified_parent' != parent.getAttribute('lang')))
		return false;
	
	if(divDrag.dupeElement) {
		divDrag.dupeElement.setAttribute('class', "divDrag_item");
		divDrag.dupeElement = null;
	}
	
	// prevent dropping of an element that is already in the group
	if(divDrag.originalElement.parentNode != parent) {
		var lang = divDrag.originalElement.getAttribute('lang');
		
		for(var i = 0; i < parent.childNodes.length; i++) {
			var node = parent.childNodes[i];
			if(node.lang == lang) {
				if(divDrag.dupeElement) {
					divDrag.dupeElement.setAttribute('class', "divDrag_item");
				}
				divDrag.dupeElement = node;
				divDrag.dupeElement.setAttribute("class", "divDrag_item divDrag_alert");
				
				scrollIntoView(divDrag.dupeElement);
				return false;
			}
		}
	}
	
	divDrag.parent = parent;
	
	// add the placeholder
	divDragRemovePlaceholder();
	divDrag.parent.appendChild(divDragPlaceholder());
	return true;
}


// inserts the element at the placeholder's location and cleans up
function divDragFinishDrag() {
	var oldclass = divDrag.originalElement.getAttribute('class') ? divDrag.originalElement.getAttribute('class') : '';
	divDrag.originalElement.setAttribute('class', oldclass.replace(/ *divDrag_original(Cloned)?/g, ''));
	
	if(divDrag.placeholder && divDrag.parent) {
		if("divDrag_not_a_parent" == divDrag.originalElement.parentNode.lang) {
			var clone = divDrag.originalElement.cloneNode(true);
			divDrag.parent.insertBefore(clone, divDrag.placeholder);
		}
		else {
			divDrag.parent.insertBefore(divDrag.originalElement, divDrag.placeholder);
		}
	}
	
	if(divDrag.element) {
		divDrag.element.parentNode.removeChild(divDrag.element);
		divDrag.element = null;
	}
	
	divDragRemovePlaceholder();
	
	divDrag.originX = 0;
	divDrag.originY = 0;
	divDrag.parent = null;
	divDrag.originalElement = null;
	divDrag.elementHeight = 0;
	
	if(divDrag.dupeElement) {
		divDrag.dupeElement.setAttribute('class', "divDrag_item");
		divDrag.dupeElement = null;
	}
}



function divDragAnimateTo() {
	var now = (new Date()).getTime();
	
	if(now < divDrag.returnStop) {
		var delta = (now - divDrag.returnStart) / divDrag.animDuration;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		
		var thisX = ((divDrag.originX - divDrag.startX) * factor) + 1* divDrag.startX;
		var thisY = ((divDrag.originY - divDrag.startY) * factor) + 1* divDrag.startY;
		divDrag.element.style.left = thisX + "px";
		divDrag.element.style.top = thisY + "px";
		
		setTimeout("divDragAnimateTo()", 10);
	}
	else {
		divDrag.element.style.left = divDrag.originX + "px";
		divDrag.element.style.top = divDrag.originY + "px";
		
		divDragFinishDrag();
	}
}


// creates the draggable representation of an element (progenitor)
function divDragDraggableElement(event) {
	var element = document.createElement('div');
	element.setAttribute("class", "divDrag_drag");
	
	var left = document.createElement('div');
	left.setAttribute('class', "divDrag_dragLeft");
	element.appendChild(left);
	var right = document.createElement('div');
	right.setAttribute('class', "divDrag_dragRight");
	element.appendChild(right);
	
	// set inner HTML
	var progenitor = event ? event.target : null;
	var prog_title = progenitor && progenitor.innerHTML ? progenitor.innerHTML.replace(/ +/g, '&nbsp;') : "Drag";
	prog_title = (prog_title.length > 25) ? prog_title.substr(0, 25) + '...' : prog_title;
	element.innerHTML += "<span>" + prog_title + "</span>";
	getObj('prefDiv').appendChild(element);
	
	var height = element.offsetHeight;
	divDrag.elementHeight = height;
	
	// position
	if(event) {
		var xy = getAbsoluteCoordinates(element).split(':');
		divDrag.originX = xy[0];
		divDrag.originY = xy[1] - 2;
		
		element.style.left = (1* event.x + 10) + "px";
		element.style.top = (event.y - (height / 3)) + "px";
	}
	
	return element;
}

// creates a placeholder
function divDragPlaceholder() {
	var placeholder = document.createElement("div");
	placeholder.setAttribute("class", "divDrag_empty");
	divDrag.placeholder = placeholder;
	
	return placeholder;
}

function divDragRemovePlaceholder() {
	if(!divDrag.placeholder)
		return;
	
	divDrag.placeholder.parentNode.removeChild(divDrag.placeholder);
	divDrag.placeholder = null;
}




/*****************
 *  Scrollwheel  *
 *****************/

function scrollwheel(event, whatdiv, scrollerID)
{
	if (scrollerStack[scrollerID].scrollTrack.style.display == 'none') return;
	delta = window.event.wheelDelta/10;
	// delta > 0 rad nach oben
	// delta < 0 rad nach unten
	
	scrollBy(scrollerID, delta);
	calculateAndShowThumb(scrollerID, whatdiv);
}





/*******************
 * Sheet Animation *
 *******************/

var sheetAnim = { obj:null, start:null, stop:null, time:300, to:0, size:200 }		// size must be the size of the inner sheet (CSS)
var sheetHeight = { filters_sheet:172 };

function showSheet(id) {
	sheetAnim.size = sheetHeight[id] ? sheetHeight[id] : sheetAnim.size;
	if(sheetAnim.to == sheetAnim.size)
		return;
	
	var obj = getObj(id);
	sheetAnim.obj = obj.parentNode;
	
	// set animation-variables
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = sheetAnim.size;
	setTimeout("animateSheet();", 10);
}

function animateSheet() {
	var now = (new Date()).getTime();
	if (now < sheetAnim.stop)
	{
		var delta = (now - sheetAnim.start) / sheetAnim.time;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var size = (sheetAnim.to < 1) ? (sheetAnim.size - (sheetAnim.size * factor)) : (sheetAnim.to * factor);
		debug(size);
		sheetAnim.obj.style.height = size + "px";
		
		setTimeout("animateSheet();", 10);
	} else {
		sheetAnim.obj.style.height = sheetAnim.to + "px";
		sheetAnim.obj = null;
	}
}

function hideSheet(id) {
	if(sheetAnim.to == 0)
		return;
	
	var obj = getObj(id);
	sheetAnim.obj = obj.parentNode;
	
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = 0;
	setTimeout("animateSheet();", 10);
}







function reverseString(forward)
{
	var reverse = "";
	for (i = forward.length-1; i >= 0; i--)
	{
		reverse += forward.substring(i, 1);
	}
	return reverse;
}

// takes an object to blur OR the name of an object to blur
function blurItem(name) {
	obj = getObj(name);
	if(obj) {
		obj.style.opacity = 0.4;
	}
}

// takes an object to blur OR the name of an object to blur
function unblurItem(name) {
	obj = getObj(name);
	if(obj) {
		obj.style.opacity = 0.99;			// gets hidden when we use 1.0. Anyone knows why? Fix for 2.0 if possible!
	}
}


// scrolls a div
var divScroll = { kind:'native', parent:null, from:0, to:0, start:null, end:null, duration:250 }

// does only work with native scrollbars!
function scrollIntoView(item) {
	item = getObj(item);
	if(item) {
		var parent = item.offsetParent;
		var content_top = parent.scrollTop;
		
		var item_top = item.offsetTop;
		var item_bottom = item_top + item.offsetHeight;
		
		var item_height = item.offsetHeight;
		var visible_height = parent.offsetHeight;
		
		if((item_top < content_top) || (item_top - content_top) > (visible_height - item_height)) {
			
			// are we already scrolling?
			if(divScroll.parent && divScroll.parent == parent) {
				return;
			}
			
			// finish old scrolling
			else if(divScroll.parent) {
				divScroll.end = 0;
				animateScrollDivTo()
			}
			
			// init
			var now = (new Date()).getTime();
			divScroll.kind = 'native';
			divScroll.parent = parent;
			divScroll.from = content_top;
			divScroll.to = (item_top < content_top) ? item_top : item_top - (visible_height - item_height);
			divScroll.start = now;
			divScroll.end = divScroll.start + divScroll.duration;
			animateScrollDivTo();
		}
	}
}

// this does only work with faked scrollbars!
function scrollIntoView2(item, parent) {
	item = getObj(item);
	if(item) {
		parent = getObj(parent);
		parent = parent ? parent : item.parentNode;
		
		var content_top = parseInt(parent.style.top);
		var item_top = item.offsetTop + content_top;
		var item_bottom = item_top + item.offsetHeight;
		
		var diff = item_bottom - parent.parentNode.offsetHeight;
		
		// init
		if((item_top < 0) || (diff > 0)) {
			
			// are we already scrolling?
			if(divScroll.parent && divScroll.parent == parent) {
				return;
			}
			
			// finish old scrolling
			else if(divScroll.parent) {
				divScroll.end = 0;
				animateScrollDivTo()
			}
			
			var now = (new Date()).getTime();
			divScroll.kind = 'faked';
			divScroll.parent = parent;
			divScroll.from = content_top;
			divScroll.start = now;
			divScroll.end = divScroll.start + divScroll.duration;
			
			// top in view?
			if(item_top < 0) {
				divScroll.to = (-1 * item.offsetTop);
			}
			
			// bottom in view?
			else if(diff > 0) {
				divScroll.to = (content_top - diff - 1);						// -1: compensate for a 1px border
				if(item.offsetHeight > parent.parentNode.offsetHeight) {		// don't scroll top out of sight when item is higher than the view!
					divScroll.to = (-1 * item.offsetTop);
				}
			}
			
			animateScrollDivTo();
		}
	}
}


// when in magazine view, scrolls to given hours (full hours only!) or to "now"
function scrollMagazineViewTo(to, no_anim) {
	if('magazine' != displaySetting['mode']) {
		return;
	}
	
	// calculate position
	var this_morning = new Date();
	if(this_morning.getHours() < magazineViewStartHour) {
		this_morning.setDate(this_morning.getDate() - 1);
	}
	this_morning.setDate(this_morning.getDate() + 1*displaySetting['day']);
	var to_show = new Date(_now);
	to_show.setDate(to_show.getDate() + 1*displaySetting['day']);
	if('now' != to) {
		if('primetime' == to) {
			to_show.setHours(20);		to_show.setMinutes("CH" == currentLocale() ? 0 : 15);
		}
		else {
			var foo = to ? to.split(":") : new Array();
			to_show.setHours(foo[0]);
			to_show.setMinutes(foo[1]);
		}
		if(this_morning.getHours() < magazineViewStartHour) {
			to_show.setDate(to_show.getDate() - 1);
		}
	}
	this_morning.setHours(magazineViewStartHour);		this_morning.setMinutes(30);		this_morning.setSeconds(0);		this_morning.setMilliseconds(0);
	
	var parent = getObj('content');
	var vis_height = getObj('contentborder').offsetHeight;
	var scroll_to_minute = (to_show.getTime() - this_morning.getTime()) / 1000 / 60;
	var to = ((-1 * scroll_to_minute * magazineViewScaleFactor) + (vis_height / 3));
	
	// are we already scrolling?
	if(divScroll.parent && divScroll.parent == parent) {
		return;
	}
	
	// finish old scrolling
	else if(divScroll.parent) {
		divScroll.end = 0;
		animateScrollDivTo()
	}
	
	var now = (new Date()).getTime();
	divScroll.kind = 'faked';
	divScroll.parent = parent;
	divScroll.from = parseInt(parent.style.top ? parent.style.top : 0);
	divScroll.to = to;
	divScroll.start = now;
	divScroll.end = no_anim ? 0 : (divScroll.start + divScroll.duration);
	
	animateScrollDivTo();
}


// this does the magic scrolling
function animateScrollDivTo() {
	if(divScroll.parent) {
		var now = (new Date()).getTime();
		
		if(divScroll.end > now) {
			var delta = (now - divScroll.start) / divScroll.duration;
			var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
			var to = (divScroll.from * (1-factor)) + (factor * divScroll.to);
			
			if('native' == divScroll.kind) {
				divScroll.parent.scrollTop = to;
			}
			else {
				divScroll.parent.style.top = to + "px";
				if('content' == divScroll.parent.id) {
					updateMagazineViewToScrollPosition();				// !! we could use "scrollBy()" from Scroller.js instead...
				}
			}
			
			setTimeout("animateScrollDivTo()", 10);
		}
		
		// end
		else {
			if('native' == divScroll.kind) {
				divScroll.parent.scrollTop = divScroll.to;
			}
			else {
				divScroll.parent.style.top = divScroll.to + "px";
				if('content' == divScroll.parent.id) {
					updateMagazineViewToScrollPosition();
					calculateAndShowThumb('myScrollBar', divScroll.parent);
				}
			}
			
			divScroll.parent = null;
			divScroll.from = 0;
			divScroll.to = 0;
			divScroll.start = 0;
			divScroll.end = 0;
		}
	}
}


/*
 * SIDEWAY scroll
 */

var sidewaysScroll = { elem:null, interval:null, rate:30 }


// scrolls sideways
function scrollElemRight(elem, jump) {
	elem = getObj(elem);
	if(elem) {
		sidewaysScroll.elem = elem;
		if(jump) {
			scrollSideways(0, 'right');
		}
		else {
			clearInterval(sidewaysScroll.interval);
			sidewaysScroll.interval = setInterval("scrollSideways(-6)", sidewaysScroll.rate);
		}
	}
}

function scrollElemLeft(elem, jump) {
	elem = getObj(elem);
	if(elem) {
		sidewaysScroll.elem = elem;
		if(jump) {
			scrollSideways(0, 'left');
		}
		else {
			clearInterval(sidewaysScroll.interval);
			sidewaysScroll.interval = setInterval("scrollSideways(6)", sidewaysScroll.rate);
		}
	}
}


// sets style.left in order to scroll
function scrollSideways(much, jump_to) {
	if(sidewaysScroll.elem) {
		if(isNaN(much)) {
			much = 6;
		}
		
		var current = parseInt(sidewaysScroll.elem.style.left);
		current = isNaN(current) ? 0 : current;
		var next = 1* current + much;
		if(jump_to) {
			next = ('left' == jump_to) ? 0 : sidewaysScroll.elem.parentNode.offsetWidth - sidewaysScroll.elem.offsetWidth;
		}
		
		var scrollLeft = getObj('scrollLeft');
		var scrollRight = getObj('scrollRight');
		
		// we mustn't scroll at all
		if(sidewaysScroll.elem.parentNode.offsetWidth > sidewaysScroll.elem.offsetWidth) {
			next = 0;
			scrollLeft.style.display = 'none';
			scrollRight.style.display = 'none';
			
			stopSidewaysScroll();
		}
		
		// we are fully left
		else if(next >= 0) {
			next = 0;
			scrollLeft.style.display = 'none';
			scrollRight.style.display = 'block';
			
			stopSidewaysScroll();
		}
		
		// we are fully right
		else if(next < (sidewaysScroll.elem.parentNode.offsetWidth - sidewaysScroll.elem.offsetWidth)) {
			next = sidewaysScroll.elem.parentNode.offsetWidth - sidewaysScroll.elem.offsetWidth;
			scrollLeft.style.display = 'block';
			scrollRight.style.display = 'none';
			
			stopSidewaysScroll();
		}
		
		// somewhere in the middle
		else {
			scrollLeft.style.display = 'block';
			scrollRight.style.display = 'block';
		}
		
		// do it!
		sidewaysScroll.elem.style.left = next + 'px';
		scrollLeft.style.left = (-1 * next) + 'px';
		scrollRight.style.left = (-1 * next + sidewaysScroll.elem.parentNode.offsetWidth - scrollRight.offsetWidth - 8) + 'px';		// 8px is covered by the scrollbar
		for(var i = 1; i <= 24; i++) {
			getObj("magazineHourIndicator_" + i).style.paddingLeft = ((-1 * next) + 20) + "px";
		}
	}
}

// stop
function stopSidewaysScroll() {
	if(null != sidewaysScroll.interval)
		clearInterval(sidewaysScroll.interval);
	sidewaysScroll.interval = null;
}



// called by scrollBy() and scrollPage() from Scroller.js and scrollIntoView2() from GUI.js; adjusts the channel header positions, the date displayed and the show-content
var magazineViewIsOnNextDay = false;
function updateMagazineViewToScrollPosition() {
	if('magazine' == displaySetting['mode']) {
		var cont = getObj('magazineChannelContainer');
		if(cont) {
			var topdistance = parseInt(cont.parentNode.style.top);
			cont.style.top = (topdistance * -1) + "px";
			
			// scrolled down that many hours
			var minutes_same_day = (24 * 60) - ((60 * firstShowStamp.getHours()) + firstShowStamp.getMinutes());
			var scrolled_minutes = Math.floor(topdistance / magazineViewScaleFactor) * -1;
			
			// update title and toolbar (only if necessary)
			if(magazineViewIsOnNextDay != (scrolled_minutes > minutes_same_day)) {
				if(scrolled_minutes > minutes_same_day) {				// we scrolled to next day
					magazineViewIsOnNextDay = true;
					var tomorrow = new Date(firstShowStamp);		tomorrow.setDate(tomorrow.getDate() + 1);
					displayTitle(dayAndDate(tomorrow));
					toolbarItems['toolbarDay'].update(tomorrow);
				}
				else {													// we are on same day
					magazineViewIsOnNextDay = false;
					displayTitle(dayAndDate(firstShowStamp));
					toolbarItems['toolbarDay'].update();
				}
			}
		}
		
		// show the big hour-letters while scrolling
		if(magazineViewHoursTimeout) {
			clearTimeout(magazineViewHoursTimeout);
			magazineViewHoursTimeout = setTimeout("hideMagazineViewHours()", 1500);
		}
		else {
			showMagazineViewHours();
		}
		
		// adjust show text boxes so that the text is always visible (if possible)
		var scrolltop = -1 * parseInt(getObj('content').style.top);
		for(var id in showHash) {
			var top = parseInt(showHash[id].p.style.top);
			if(top < scrolltop) {
				var bottom = top + parseInt(showHash[id].p.style.height);
				
				// still visible, lex do it!
				if(bottom > scrolltop) {
					var tot_height = showHash[id].p.offsetHeight;
					var box_height = showHash[id].p.lastChild.offsetHeight;
					if(tot_height > box_height) {
						var top_dist = scrolltop - top;
						top_dist = (top_dist > (tot_height - box_height - 10)) ? (tot_height - box_height - 10) : top_dist;
						showHash[id].p.lastChild.style.top = top_dist + 'px';
					}
				}
			}
			else {
				showHash[id].p.lastChild.style.top = '';
			}
		}
	}
}


// sets the hours on the background of the magazineView visible
function showMagazineViewHours() {
	if(magazineViewHoursTimeout) {
		clearTimeout(magazineViewHoursTimeout);
		magazineViewHoursTimeout = null;
	}
	
	for(var i = 1; i <= 24; i++) {
		getObj("magazineHourIndicator_" + i).style.color = "rgb(40,40,40)";
	}
	
	magazineViewHoursTimeout = setTimeout("hideMagazineViewHours()", 2000);
}

// starts the animation to hide those hours
var magazineViewHoursTimeout = null;
function hideMagazineViewHours() {
	if('magazine' != displaySetting['mode']) {		// maybe we already switched to another mode...
		return;
	}
	if(magazineViewHoursTimeout) {
		clearTimeout(magazineViewHoursTimeout);
		magazineViewHoursTimeout = null;
	}
	
	animMagazineViewHours.start = (new Date()).getTime();
	animMagazineViewHours.end = animMagazineViewHours.start + animMagazineViewHours.duration;
	animateMagazineViewHours();
}

var animMagazineViewHours = { start:null, end:null, duration:300, from:1, to:0 };
function animateMagazineViewHours() {
	var now = (new Date()).getTime();
	
	// animation
	if(animMagazineViewHours.end > now) {
		var delta = (now - animMagazineViewHours.start) / animMagazineViewHours.duration;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var current = (animMagazineViewHours.from * (1-factor)) + (factor * animMagazineViewHours.to);
		
		for(var i = 1; i <= 24; i++) {
			getObj("magazineHourIndicator_" + i).style.color = "rgba(40,40,40," + current + ")";
		}
		
		setTimeout("animateMagazineViewHours()", 50);
	}
	
	// end
	else {
		for(var i = 1; i <= 24; i++) {
			var obj = getObj("magazineHourIndicator_" + i);
			if(obj) {
				obj.style.color = "rgba(40,40,40," + animMagazineViewHours.to + ")";
			}
		}
		
		animMagazineViewHours.start = 0;
		animMagazineViewHours.end = 0;
	}
}






/*
 **************************
 * Collapse/Expand Widget *
 **************************
 */
 
function isCollapsed()
{
	return (window.innerHeight < 100);
}

var standardExpandCollapseTime = 400;
var longExpandCollapseTime = 4000;
var toHideObjects = new Array('flip', 'controlbar', 'frontResize');			// will FADE while collapsing
var toBlockObjects = new Array('myScrollBar', 'myDrawerScrollBar');			// will IMMEDIATELY be invisible while collapsing
var widgetAnim = { width:0, expandedHeight:0, collapsedHeight:56, startsize:0, widgetExpanding:false, stop:0, start:0, duration:0, didSwap:false, imagesLoaded:false };


function toggleWidget(event) {
	hideDrawer();
	stopProgressAnim("mainProgress");
	
	widgetAnimPreloadImages();			// only loads if it has not already done so
	
	var height = window.innerHeight;
	
	widgetAnim.duration = (event && event.shiftKey) ? longExpandCollapseTime : standardExpandCollapseTime;
	widgetAnim.width = window.innerWidth;
	widgetAnim.startsize = height;
	widgetAnim.start = (new Date).getTime();
	widgetAnim.stop = widgetAnim.start + widgetAnim.duration;
	widgetAnim.didSwap = false;
	
	// collapse (from expanded)
	if(height > 100) {
		for(i = 0; i < toBlockObjects.length; i++) {
			getObj(toBlockObjects[i]).style.display = 'none';
		}
		
		widgetAnim.expandedHeight = height;
		widgetAnim.widgetExpanding = false;
		widgetAnim.finalsize = widgetAnim.collapsedHeight;
	}
	
	// expand (from collapsed)
	else {
		getObj('frontDiv').style.height = height + 'px';
		
		if(widgetAnim.expandedHeight < 100) {
			widgetAnim.expandedHeight = 350;
		}
		
		for(i = 0; i < toHideObjects.length; i++) {
			getObj(toHideObjects[i]).style.display = 'block';
		}
		
		widgetAnim.widgetExpanding = true;
		widgetAnim.finalsize = widgetAnim.expandedHeight;
		
		window.resizeTo(widgetAnim.width, widgetAnim.expandedHeight);
	}
	
	animateWindowTo();
}

function animateWindowTo() {
	var now = (new Date()).getTime();
	
	// *****
	// during animation
	if(now < widgetAnim.stop) {
		var delta = (now - widgetAnim.start) / widgetAnim.duration;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var size = (widgetAnim.startsize * (1-factor)) + (factor * widgetAnim.finalsize);
		
		getObj('frontDiv').style.height = size + 'px';
		
		for(i = 0; i < toHideObjects.length; i++) {
			var obj = getObj(toHideObjects[i]);
			if(obj) {
				obj.style.opacity = widgetAnim.widgetExpanding ? factor : (1-factor);
			}
		}
		
		// Once during animation: Swap background images and adjust some values (1/6th before it reaches/after it leaves the top)
		if(!widgetAnim.didSwap && now > (widgetAnim.stop - (widgetAnim.duration / 6 * (widgetAnim.widgetExpanding ? 5 : 1)))) {
			widgetAnim.didSwap = widgetAnimToggleLayout();
		}
		
		setTimeout("animateWindowTo()", 10);
	}
	
	// *****
	// last run - finalize
	else {
		window.resizeTo(widgetAnim.width, widgetAnim.finalsize);
		getObj('frontDiv').style.height = '';
		
		// finalize display/opacity
		for(i = 0; i < toHideObjects.length; i++) {
			var obj = getObj(toHideObjects[i]);
			if(obj) {
				obj.style.opacity = widgetAnim.widgetExpanding ? 1.0 : 0.0;
				obj.style.display = widgetAnim.widgetExpanding ? "block" : "none";
			}
			else {
				debug("animateWindowTo(): Object " + toHideObjects[i] + " not found");
			}
		}
		
		if(!widgetAnim.didSwap) {
			widgetAnimToggleLayout();
		}
		
		// finish up
		if(widgetAnim.widgetExpanding) {
			for(i = 0; i < toBlockObjects.length; i++) {
				getObj(toBlockObjects[i]).style.display = 'block';
			}
			
			setTimeout("checkBTAvailability()", 10);
			if(('now' == displaySetting['time']) && (!isSearchResult) /*&& (!isQuickAccessSearch)*/) {
				setTimeout("updateTVListing()", 10);
			}
		}
		
		// save state for next launch
		if(window.widget) {
			widget.setPreferenceForKey(!widgetAnim.widgetExpanding, 'isCollapsed');
		}
	}
}

function assureExpanded()
{
	if (isCollapsed()) toggleWidget();
}

function collapseImmediately() {
	if(!isCollapsed()) {
		widgetAnimPreloadImages();
		
		for(i = 0; i < toBlockObjects.length; i++) {
			getObj(toBlockObjects[i]).style.display = 'none';
		}
		for(i = 0; i < toHideObjects.length; i++) {
			getObj(toHideObjects[i]).style.display = 'none';
			getObj(toHideObjects[i]).style.opacity = 0.0;
		}
		
		widgetAnimToggleLayout();
		window.resizeTo(window.innerWidth, widgetAnim.collapsedHeight);
	}
}

function widgetAnimPreloadImages() {
	if(!widgetAnim.imagesLoaded) {
		var arr = new Array('face_topLeft_collapsed', 'face_top_collapsed', 'face_topRight_collapsed', 'face_bottomLeft_collapsed', 'face_bottom_collapsed', 'face_bottomRight_collapsed');
		
		for(var i = 0; i < arr.length; i++) {
			var img = new Image();
			img.src = "Images/" + arr[i] + ".png";
		}
	}
	
	widgetAnim.imagesLoaded = true;
}

function widgetAnimToggleLayout() {
	getObj('face_topLeft').style.backgroundImage = widgetAnim.widgetExpanding ?		null : "url(Images/face_topLeft_collapsed.png)";
	getObj('face_top').style.backgroundImage = widgetAnim.widgetExpanding ?			null : "url(Images/face_top_collapsed.png)";
	getObj('face_topRight').style.backgroundImage = widgetAnim.widgetExpanding ?	null : "url(Images/face_topRight_collapsed.png)";
	getObj('face_left').style.top = widgetAnim.widgetExpanding ?					null : "25px";
	getObj('face_left').style.bottom = widgetAnim.widgetExpanding ?					null : "31px";
	getObj('face_background').style.top = widgetAnim.widgetExpanding ?				null : "25px";
	getObj('face_background').style.bottom = widgetAnim.widgetExpanding ?			null : "31px";
	getObj('face_right').style.top = widgetAnim.widgetExpanding ?					null : "25px";
	getObj('face_right').style.bottom = widgetAnim.widgetExpanding ?				null : "31px";
	getObj('face_bottomLeft').style.backgroundImage = widgetAnim.widgetExpanding ?	null : "url(Images/face_bottomLeft_collapsed.png)";
	getObj('face_bottom').style.backgroundImage = widgetAnim.widgetExpanding ?		null : "url(Images/face_bottom_collapsed.png)";
	getObj('face_bottomRight').style.backgroundImage = widgetAnim.widgetExpanding ?	null : "url(Images/face_bottomRight_collapsed.png)";
	
	return true;
}


/*
 ************
 * by Apple *
 ************
 */


/*
 * Window-resizing (modified)
 */
 
var lastPos;

function mouseDown(event) {
	var x = event.x + window.screenX;
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	lastPos = {x:x, y:y};
	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event) {
	var myevent = { x:Math.max(event.x, 340), y:Math.max(event.y, 280) };
	var screenX = myevent.x + window.screenX;
	var screenY = myevent.y + window.screenY;
	
	window.resizeBy(screenX - lastPos.x, screenY - lastPos.y);
	
	if(!prefsShown) {
		if(drawer.current > 0) {
			var max = parseInt(getComputedValue('height', getObj('mainViewArea')));
			if(drawer.current > (drawer._maxheight * max)) {
				resizeDrawerTo(Math.round(drawer._maxheight * max));
			}
		}
		calculateAndShowThumb('myScrollBar', getObj("content"));
		calculateAndShowThumb('myDrawerScrollBar', getObj("drawercontent"));
	}

	lastPos = {x:screenX, y:screenY};
	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event) {
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true); 
	event.stopPropagation();
	event.preventDefault();
	
	// resize Drawer if it is visible
	if(drawer.current > 0) {
		resizeDrawer();
	}
	
	calculateAndShowThumb('myScrollBar', getObj("content"));
	calculateAndShowThumb('myDrawerScrollBar', getObj("drawercontent"));
		
	// save in Prefs
	if(window.widget) {
		widget.setPreferenceForKey(window.innerWidth, "windowX");
		widget.setPreferenceForKey(window.innerHeight, "windowY");
	}
}



/*
 * i-Button
 */

var flipShown = false;
var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function mousemove(event) {
	if(!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = getObj('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit(event) {
	if(flipShown) {
		
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer	= null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = getObj('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}


// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)

function enterflip(event) {
	if (getObj('flip').opacity < 0.1) return;
	getObj("fliprollie").style.display = "block";
}

function exitflip(event) {
	getObj("fliprollie").style.display = "none";
}

